import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import { FormControl } from '@angular/forms';
import { OnInit, ElementRef } from '@angular/core';
import { PerfectScrollbarComponent, PerfectScrollbarConfigInterface } from 'angular2-perfect-scrollbar';
import { FontPickerService } from './font-picker.service';
import { Font, GoogleFontInterface } from './interfaces';
export declare class FontPickerComponent implements OnInit {
    private el;
    private service;
    open: boolean;
    loading: boolean;
    top: number;
    left: number;
    position: string;
    font: Font;
    initialFont: Font;
    private styles;
    private testWidth;
    private testContainer;
    listLabel: string;
    selectedFont: boolean;
    presetVisible: boolean;
    arrowTop: number;
    fontAmount: number;
    loadedFonts: number;
    presetFonts: Font[];
    googleFonts: Font[];
    currentFonts: Font[];
    fpWidth: number;
    fpHeight: number;
    fpPosition: string;
    fpPositionOffset: number;
    fpPresetLabel: string;
    fpPresetFonts: Array<any>;
    fpSizeSelect: boolean;
    fpStyleSelect: boolean;
    fpCancelButton: boolean;
    fpCancelButtonText: string;
    fpCancelButtonClass: string;
    fpUploadButton: boolean;
    fpUploadButtonText: string;
    fpUploadButtonClass: string;
    dialogArrowSize: number;
    dialogArrowOffset: number;
    private listenerResize;
    private listenerMouseDown;
    private directiveInstance;
    private directiveElementRef;
    searchTerm: FormControl;
    config: PerfectScrollbarConfigInterface;
    dialogElement: any;
    scrollbar: PerfectScrollbarComponent;
    constructor(el: ElementRef, service: FontPickerService);
    ngOnInit(): void;
    setDialog(instance: any, elementRef: ElementRef, font: Font, fpPosition: string, fpPositionOffset: string, fpPositionRelativeToArrow: boolean, fpPresetLabel: any, fpPresetFonts: any, fpUploadButton: boolean, fpUploadButtonClass: string, fpUploadButtonText: string, fpStyleSelect: boolean, fpSizeSelect: boolean, fpCancelButton: boolean, fpCancelButtonClass: string, fpCancelButtonText: string, fpHeight: string, fpWidth: string): void;
    updateDialog(font: Font, fpPosition: string, fpPositionOffset: string, fpPositionRelativeToArrow: boolean, fpPresetLabel: any, fpPresetFonts: any, fpUploadButton: boolean, fpUploadButtonClass: string, fpUploadButtonText: string, fpStyleSelect: boolean, fpSizeSelect: boolean, fpCancelButton: boolean, fpCancelButtonClass: string, fpCancelButtonText: string, fpHeight: string, fpWidth: string): void;
    openFontPicker(): void;
    closeFontPicker(): void;
    isFontAvailable(font: Font): boolean;
    getPresetFonts(): any[];
    setDisplayedFontSource(): void;
    setCurentFonts(target: Font[]): void;
    findFont(searchVal: any, exactMatch?: boolean): Font;
    findFonts(searchVal: any, exactMatch?: boolean): Font[];
    loadMoreFonts(): void;
    loadGoogleFonts(fonts: Font[]): void;
    searchGoogleFonts(value: string): void;
    convertGoogleFont(font: GoogleFontInterface): Font;
    onResize(): void;
    onMouseDown(event: any): void;
    onUploadFiles(): void;
    onCancelSelect(): void;
    onSelectFont(font: any): void;
    onSearchReset(event?: any): void;
    onFontSizeChange(event: any, font: Font): void;
    onFontStyleChange(event: any, font: Font): void;
    isDescendant(parent: any, child: any): boolean;
    createDialogBox(element: any, offset: any): any;
    setDialogPosition(): void;
}
