"use strict";
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
var common_1 = require('@angular/common');
var forms_1 = require('@angular/forms');
var angular2_perfect_scrollbar_1 = require('angular2-perfect-scrollbar');
var font_picker_service_1 = require('./font-picker.service');
var font_picker_component_1 = require('./font-picker.component');
var font_picker_directive_1 = require('./font-picker.directive');
var interfaces_1 = require('./interfaces');
var pipes_1 = require('./pipes');
exports.FONT_PICKER_GUARD = new core_1.OpaqueToken('FONT_PICKER_GUARD');
exports.FONT_PICKER_CONFIG = new core_1.OpaqueToken('FONT_PICKER_CONFIG');
var FontPickerModule = (function () {
    function FontPickerModule(guard) {
    }
    FontPickerModule.forRoot = function (config) {
        return {
            ngModule: FontPickerModule,
            providers: [
                font_picker_service_1.FontPickerService,
                {
                    provide: exports.FONT_PICKER_GUARD,
                    useFactory: provideForRootGuard,
                    deps: [
                        [
                            interfaces_1.FontPickerConfig,
                            new core_1.Optional(),
                            new core_1.SkipSelf()
                        ]
                    ]
                },
                {
                    provide: exports.FONT_PICKER_CONFIG,
                    useValue: config ? config : {}
                },
                {
                    provide: interfaces_1.FontPickerConfig,
                    useFactory: provideDefaultConfig,
                    deps: [
                        exports.FONT_PICKER_CONFIG
                    ]
                }
            ]
        };
    };
    FontPickerModule.forChild = function () {
        return {
            ngModule: FontPickerModule
        };
    };
    FontPickerModule.decorators = [
        { type: core_1.NgModule, args: [{
                    declarations: [font_picker_component_1.FontPickerComponent, font_picker_directive_1.FontPickerDirective, pipes_1.FontSizePipe, pipes_1.FontStylesPipe, pipes_1.StatefulSlicePipe],
                    imports: [common_1.CommonModule, http_1.HttpModule, forms_1.FormsModule, forms_1.ReactiveFormsModule, angular2_perfect_scrollbar_1.PerfectScrollbarModule],
                    exports: [forms_1.FormsModule, forms_1.ReactiveFormsModule, font_picker_directive_1.FontPickerDirective, pipes_1.FontSizePipe, pipes_1.FontStylesPipe, pipes_1.StatefulSlicePipe],
                    entryComponents: [font_picker_component_1.FontPickerComponent]
                },] },
    ];
    /** @nocollapse */
    FontPickerModule.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Optional }, { type: core_1.Inject, args: [exports.FONT_PICKER_GUARD,] },] },
    ]; };
    return FontPickerModule;
}());
exports.FontPickerModule = FontPickerModule;
function provideForRootGuard(config) {
    if (config) {
        throw new Error("\n      Application called FontPickerModule.forRoot() twice.\n      For submodules use FontPickerModule.forChild() instead.\n    ");
    }
    return 'guarded';
}
exports.provideForRootGuard = provideForRootGuard;
function provideDefaultConfig(config) {
    return new interfaces_1.FontPickerConfig(config);
}
exports.provideDefaultConfig = provideDefaultConfig;
//# sourceMappingURL=font-picker.module.js.map